Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Selftest
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Selftest	(revision 144)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Selftest	(revision 145)
@@ -8,17 +8,17 @@
 
 #-----[ Directory ]----------------------------------------
-DIR_BIN				= $(DIR_TMP)/bin
-DIR_CFG_GEN			= $(DIR_TMP)/configuration_generated
+DIR_BIN				= $(DIR_TMP)/bin/$(ENTITY)
+DIR_CFG_GEN			= $(DIR_TMP)/configuration_generated/$(ENTITY)
 DIR_CFG_USER			= configuration
 DIR_LOG				= log
 
 #-----[ Variables ]----------------------------------------
-CFG_FILE_EXTENSION		= cfg
-CFG_FILE_DEBUG       		= debug.$(CFG_FILE_EXTENSION)
+CFG_FILE_PATH                   = $(DIR_CFG_USER)
+CFG_FILE_EXTENSION		= gen
+CFG_FILE_DEBUG       		= $(CFG_FILE_PATH)/debug.$(CFG_FILE_EXTENSION)
 
 OBJECTS      			= $(OBJECTS_COMMON)
 
 LIBS		   		= -lm $(SYSTEMC_LIBNAME_$(SIMULATOR_SYSTEMC))
-#                                 $(OR1K_LIBNAME) -lbfd  
 
 MODELTECH_LIBRARY               = $(addprefix -lib ,$(addsuffix .a, $(subst -l,$(DIR_LIB)/lib,$(LIBRARY))))
@@ -29,5 +29,5 @@
 EXEC_PARAMS 			= $(SYSTEMC_EXEC_PARAMS_$(SIMULATOR_SYSTEMC))
 EXEC_LOG			= $(patsubst $(DIR_CFG_GEN)/%.cfg,$(DIR_LOG)/%.exec.log,$(wildcard $(DIR_CFG_GEN)/*.cfg))	\
-				  $(patsubst $(DIR_CFG_USER)/%.cfg,$(DIR_LOG)/%.exec.log,$(wildcard $(DIR_CFG_USER)/*.cfg))
+				  $(patsubst $(DIR_CFG_USER)/%.cfg,$(DIR_LOG)/%.exec.log,$(wildcard $(DIR_CFG_GEN)/*.cfg))
 BIN				= Selftest.x
 EXEC				= $(DIR_BIN)/$(BIN)
@@ -37,5 +37,4 @@
 #.NOTPARALLEL			: clean clean_all help
 
-vpath	%.cfg	$(DIR_CFG_USER):$(DIR_CFG_GEN)
 vpath	%.x	$(DIR_BIN)
 
@@ -47,5 +46,5 @@
 execute_only                    : 
 				@\
-				$(MAKE) $(EXEC_LOG);					\
+                                $(MAKE) $(EXEC_LOG);\
 				declare -i all_ok=1;					\
 				for i in $(EXEC_LOG); do				\
@@ -86,5 +85,5 @@
 					files=$(CFG_FILE_DEBUG);									\
 				else													\
-					files=$$($(LS) *.$(CFG_FILE_EXTENSION) );							\
+					files=$$($(LS) $(CFG_FILE_PATH)/*.$(CFG_FILE_EXTENSION) );							\
 				fi;													\
 																	\
@@ -172,5 +171,5 @@
 				done;
 
-$(DIR_LOG)/%.exec.log		: %.cfg  $(EXEC)
+$(DIR_LOG)/%.exec.log		: $(DIR_CFG_GEN)/%.cfg  $(EXEC)
 				@\
 				$(ECHO) "Execute            : $*";\
@@ -218,8 +217,17 @@
 				esac;
 
-$(DIR_BIN) $(DIR_LOG) $(DIR_CFG_GEN) :
+$(DIR_BIN) $(DIR_LOG)		:
 				@\
 				$(ECHO) "Create directory   : $@";\
-				$(MKDIR) $@;
+				$(MKDIR) $@;\
+
+$(DIR_CFG_GEN)			:
+				@\
+				$(ECHO) "Create directory   : $@";\
+				$(MKDIR) $@;\
+				$(LS) $(DIR_CFG_USER)/*.cfg &> /dev/null; \
+				if $(TEST) $$? -eq 0; then \
+					$(CP) $(DIR_CFG_USER)/*.cfg $@; \
+				fi;
 
 selftest_clean			: local_clean config_clean 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.mkf
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.mkf	(revision 144)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.mkf	(revision 145)
@@ -3,8 +3,11 @@
 #
 
-all: _Generic/Queue/SelfTest _Generic/RegisterFile/RegisterFile_Monolithic/SelfTest _Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest
+all: _Generic/Queue/SelfTest _Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest _Generic/RegisterFile/RegisterFile_Monolithic/SelfTest _Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest
 
 _Generic/Queue/SelfTest:
 	gmake all -C Generic/Queue/SelfTest
+
+_Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest:
+	gmake all -C Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest
 
 _Generic/RegisterFile/RegisterFile_Monolithic/SelfTest:
@@ -16,4 +19,5 @@
 clean:
 	gmake clean -C Generic/Queue/SelfTest
+	gmake clean -C Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest
 	gmake clean -C Generic/RegisterFile/RegisterFile_Monolithic/SelfTest
 	gmake clean -C Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest
@@ -23,4 +27,5 @@
 install:
 	gmake install -C Generic/Queue/SelfTest
+	gmake install -C Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest
 	gmake install -C Generic/RegisterFile/RegisterFile_Monolithic/SelfTest
 	gmake install -C Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component_vbe/SelfTest/configuration/configuration.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component_vbe/SelfTest/configuration/configuration.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component_vbe/SelfTest/configuration/configuration.gen	(revision 145)
@@ -0,0 +1,1 @@
+@COMPONENT
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component_vst/SelfTest/configuration/configuration.gen
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component_vst/SelfTest/configuration/configuration.gen	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/New_Component_vst/SelfTest/configuration/configuration.gen	(revision 145)
@@ -0,0 +1,1 @@
+@COMPONENT
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 144)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Allocation.h	(revision 145)
@@ -14,17 +14,21 @@
 // =====[ ALLOCATION / DELETE of ARRAY ]=================================
 // ======================================================================
-#define ALLOC0(var,type)                        \
+#define ALLOC0_COND(var,type,cond)              \
   do                                            \
     {                                           \
-      var = new type;                           \
-    } while (0)
-
-#define ALLOC1(var,type,s1)                     \
+      if (cond)                                 \
+        var = new type;                         \
+    } while (0)
+
+
+#define ALLOC1_COND(var,type,s1,cond)           \
   do                                            \
     {                                           \
-      var = new type [s1];                      \
-    } while (0)
-
-#define ALLOC2(var,type,s1,s2)                   \
+      if (cond)                                 \
+        var = new type [s1];                    \
+    } while (0)
+
+
+#define ALLOC2_COND(var,type,s1,s2,cond)         \
   do                                             \
     {                                            \
@@ -32,9 +36,10 @@
       for (uint32_t it1=0; it1<s1; ++it1)        \
         {                                        \
-          var [it1] = new type [s2];             \
+          if (cond)                              \
+            var [it1] = new type [s2];           \
         }                                        \
     } while (0)
 
-#define ALLOC3(var,type,s1,s2,s3)                \
+#define ALLOC3_COND(var,type,s1,s2,s3,cond)      \
   do                                             \
     {                                            \
@@ -45,50 +50,62 @@
           for (uint32_t it2=0; it2<s2; ++it2)    \
             {                                    \
-              var [it1][it2] = new type [s3];    \
+              if (cond)                          \
+                var [it1][it2] = new type [s3];  \
             }                                    \
         }                                        \
     } while (0)
 
-#define ALLOC4(var,type,s1,s2,s3,s4)                    \
-  do                                                    \
-    {                                                   \
-      var = new type *** [s1];                          \
-      for (uint32_t it1=0; it1<s1; ++it1)               \
-        {                                               \
-          var [it1] = new type ** [s2];                 \
-          for (uint32_t it2=0; it2<s2; ++it2)           \
-            {                                           \
-              var [it1][it2] = new type * [s3];         \
-              for (uint32_t it3=0; it3<s3; ++it3)       \
-                {                                       \
-                  var [it1][it2][it3] = new type [s4];  \
-                }                                       \
-            }                                           \
-        }                                               \
-    } while (0)
-
-#define DELETE0(var)                            \
+#define ALLOC4_COND(var,type,s1,s2,s3,s4,cond)                  \
+  do                                                            \
+    {                                                           \
+      var = new type *** [s1];                                  \
+      for (uint32_t it1=0; it1<s1; ++it1)                       \
+        {                                                       \
+          var [it1] = new type ** [s2];                         \
+          for (uint32_t it2=0; it2<s2; ++it2)                   \
+            {                                                   \
+              var [it1][it2] = new type * [s3];                 \
+              for (uint32_t it3=0; it3<s3; ++it3)               \
+                {                                               \
+                  if (cond)                                     \
+                    var [it1][it2][it3] = new type [s4];        \
+                }                                               \
+            }                                                   \
+        }                                                       \
+    } while (0)
+
+#define ALLOC0(var,type)             ALLOC0_COND(var,type,true)
+#define ALLOC1(var,type,s1)          ALLOC1_COND(var,type,s1,true)
+#define ALLOC2(var,type,s1,s2)       ALLOC2_COND(var,type,s1,s2,true)
+#define ALLOC3(var,type,s1,s2,s3)    ALLOC3_COND(var,type,s1,s2,s3,true)
+#define ALLOC4(var,type,s1,s2,s3,s4) ALLOC4_COND(var,type,s1,s2,s3,s4,true)
+
+
+#define DELETE0_COND(var,cond)                  \
   do                                            \
     {                                           \
-      delete var;                               \
-    } while (0)
-
-#define DELETE1(var,s1)                         \
+      if (cond)                                 \
+        delete var;                             \
+    } while (0)
+
+#define DELETE1_COND(var,s1,cond)               \
   do                                            \
     {                                           \
-      delete [] var;                            \
-    } while (0)
-
-#define DELETE2(var,s1,s2)                      \
+      if (cond)                                 \
+        delete [] var;                          \
+    } while (0)
+
+#define DELETE2_COND(var,s1,s2,cond)            \
   do                                            \
     {                                            \
       for (uint32_t it1=0; it1<s1; ++it1)        \
         {                                        \
-          delete [] var [it1];                   \
+          if (cond)                              \
+            delete [] var [it1];                 \
         }                                        \
       delete [] var;                             \
     } while (0)
 
-#define DELETE3(var,s1,s2,s3)                    \
+#define DELETE3_COND(var,s1,s2,s3,cond)          \
   do                                             \
     {                                            \
@@ -97,5 +114,6 @@
           for (uint32_t it2=0; it2<s2; ++it2)    \
             {                                    \
-              delete [] var [it1][it2];          \
+              if (cond)                          \
+                delete [] var [it1][it2];        \
             }                                    \
           delete [] var [it1];                   \
@@ -104,5 +122,5 @@
     } while (0)
 
-#define DELETE4(var,s1,s2,s3,s4)                        \
+#define DELETE4_COND(var,s1,s2,s3,s4,cond)              \
   do                                                    \
     {                                                   \
@@ -113,5 +131,6 @@
               for (uint32_t it3=0; it3<s3; ++it3)       \
                 {                                       \
-                  delete [] var [it1][it2][it3];        \
+                  if (cond)                             \
+                    delete [] var [it1][it2][it3];      \
                 }                                       \
               delete [] var [it1][it2];                 \
@@ -121,4 +140,10 @@
       delete [] var;                                    \
     } while (0)
+
+#define DELETE0(var)             DELETE1_COND(var,true)
+#define DELETE1(var,s1)          DELETE1_COND(var,s1,true)
+#define DELETE2(var,s1,s2)       DELETE2_COND(var,s1,s2,true)
+#define DELETE3(var,s1,s2,s3)    DELETE3_COND(var,s1,s2,s3,true)
+#define DELETE4(var,s1,s2,s3,s4) DELETE4_COND(var,s1,s2,s3,s4,true)
 
 // ======================================================================
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Debug_component.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Debug_component.h	(revision 144)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Debug_component.h	(revision 145)
@@ -19,4 +19,5 @@
 #  define       DEBUG_Queue_Control                               true 
 #  define       DEBUG_RegisterFile                                true
+#  define         DEBUG_RegisterFile_Internal_Banked              true 
 #  define         DEBUG_RegisterFile_Monolithic                   true 
 #  define         DEBUG_RegisterFile_Multi_Banked                 true
@@ -119,4 +120,5 @@
 #  define NAME_Queue_Control                              "Queue_Control"
 #  define NAME_RegisterFile                               "RegisterFile"
+#  define NAME_RegisterFile_Internal_Banked               "RegisterFile_Internal_Banked"
 #  define NAME_RegisterFile_Monolithic                    "RegisterFile_Monolithic"
 #  define NAME_RegisterFile_Multi_Banked                  "RegisterFile_Multi_Banked"
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Function_pointer.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Function_pointer.h	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Function_pointer.h	(revision 145)
@@ -0,0 +1,37 @@
+#ifndef morpheo_behavioural_Function_pointer_h
+#define morpheo_behavioural_Function_pointer_h
+# if 0
+
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include <list>
+#include "systemc.h"
+
+namespace morpheo     {
+namespace behavioural {
+  
+  typedef void(sc_process_host::*f_t)(void);
+
+  class Function_pointer
+  {
+  private : std::list<f_t> * _transition;
+  private : std::list<f_t> * _genMoore  ;
+
+  public  :       Function_pointer (void);
+  public  :      ~Function_pointer (void);
+  public  : void transition_add    (f_t f);
+  public  : void transition_exec   (void);
+  public  : void genMoore_add      (f_t f);
+  public  : void genMoore_exec     (void);
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+
+# endif
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/mkf.info
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/mkf.info	(revision 144)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/mkf.info	(revision 145)
@@ -16,4 +16,5 @@
 # build src directory content
  target_dep		all		Generic/Queue/SelfTest
+ target_dep		all		Generic/RegisterFile/RegisterFile_Internal_Banked/SelfTest
  target_dep		all		Generic/RegisterFile/RegisterFile_Monolithic/SelfTest
  target_dep		all		Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Function_pointer.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Function_pointer.cpp	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Function_pointer.cpp	(revision 145)
@@ -0,0 +1,28 @@
+#if 0
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Function_pointer.h"
+
+namespace morpheo     {
+namespace behavioural {
+  
+  Function_pointer::Function_pointer (void)
+  {
+    _transition = new std::list<f_t>;
+    _genMoore   = new std::list<f_t>;
+  }
+  
+  Function_pointer::~Function_pointer (void)
+  {
+    delete _transition;
+    delete _genMoore  ;
+  }
+  
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Function_pointer_add.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Function_pointer_add.cpp	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Function_pointer_add.cpp	(revision 145)
@@ -0,0 +1,26 @@
+#if 0
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Function_pointer.h"
+
+namespace morpheo     {
+namespace behavioural {
+  
+  void Function_pointer::transition_add (f_t f)
+  {
+    _transition->push_back(f);
+  }
+  
+  void Function_pointer::genMoore_add (f_t f)
+  {
+    _genMoore->push_back(f);
+  }
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Function_pointer_exec.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Function_pointer_exec.cpp	(revision 145)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Function_pointer_exec.cpp	(revision 145)
@@ -0,0 +1,32 @@
+#if 0
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Function_pointer.h"
+
+namespace morpheo     {
+namespace behavioural {
+  
+  void Function_pointer::transition_exec (void)
+  {
+    // for (std::list<f_t>::iterator it=_transition->begin();
+    //      it!=_transition->end();
+    //      ++it)
+    //   (*it)();
+  }
+  
+  void Function_pointer::genMoore_exec (void)
+  {
+    // for (std::list<f_t>::iterator it=_genMoore->begin();
+    //      it!=_genMoore->end();
+    //      ++it)
+    //   (*it)();
+  }
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
